package MinigolfCommandOverride
{
	function scrollInventory(%val) 
	{
		if (!isGolfball() || $ZoomOn || $ScrollMode != $SCROLLMODE_NONE) 
		{
			parent::scrollInventory(%val);
			return;
		}

		if ($golfMode $= "Look") 
		{
			commandToServer('golfballZoom', %val);
		}
		else if ($golfMode $= "Aim")
		{
			// commandToServer('golfballPower', %val);
			adjustGolfballPower(%val);
		}
		else 
		{
			parent::scrollInventory(%val);
		}
	}

	function toggleFirstPerson(%val) 
	{
		if (!isGolfball()) 
		{
			parent::toggleFirstPerson(%val);
		}
		else if (%val)
		{
			$firstPerson = 1;
			commandToServer('toggleGolfMode');
		}
	}

	function Jump(%val) {
		if (!isGolfball()) 
		{
			parent::Jump(%val);
		}
		else if (%val)
		{
			commandToServer('setGolfballPower', $puttPower);
			commandToServer('golfballPutt');
		}
	}

	function shiftBrickAway(%val) {
		if (!isGolfball()) 
		{
			parent::shiftBrickAway(%val);
		}
		else if (%val)
		{
			if ($golfMode $= "Look") 
			{
				commandToServer('golfballZoom', 1);
				return;
			}

			adjustGolfballPower(1);
			cancel($golfBallPowerLoop);
			$golfBallPowerLoop = schedule(500, 0, adjustGolfballPowerLoop, 1);
		}
		else 
		{
			cancel($golfBallPowerLoop);
		}
	}

	function shiftBrickTowards(%val) {
		if (!isGolfball()) 
		{
			parent::shiftBrickTowards(%val);
		}
		else if (%val)
		{
			if ($golfMode $= "Look") 
			{
				commandToServer('golfballZoom', -1);
				return;
			}

			adjustGolfballPower(-1);
			cancel($golfBallPowerLoop);
			$golfBallPowerLoop = schedule(500, 0, adjustGolfballPowerLoop, -1);
		}
		else 
		{
			cancel($golfBallPowerLoop);
		}
	}

	function moveForward(%val) {
		if (!isGolfball()) 
		{
			parent::moveForward(%val);
		}
		else if (%val)
		{
			adjustGolfballPower(1);
			cancel($golfBallPowerLoop);
			$golfBallPowerLoop = schedule(500, 0, adjustGolfballPowerLoop, 1);
		}
		else 
		{
			cancel($golfBallPowerLoop);
		}
	}

	function moveBackward(%val) {
		if (!isGolfball()) 
		{
			parent::moveBackward(%val);
		}
		else if (%val)
		{
			adjustGolfballPower(-1);
			cancel($golfBallPowerLoop);
			$golfBallPowerLoop = schedule(500, 0, adjustGolfballPowerLoop, -1);
		}
		else 
		{
			cancel($golfBallPowerLoop);
		}
	}
};

function adjustGolfballPowerLoop(%val) {
	cancel($golfBallPowerLoop);

	adjustGolfballPower(%val);

	$golfBallPowerLoop = schedule(40, 0, adjustGolfballPowerLoop, %val);
}

function adjustGolfballPower(%val) 
{
	if (getSimTime() - $lastPowerAdjustTime < 50) 
	{
		%mod = 0.025;
	}
	else if (getSimTime() - $lastPowerAdjustTime < 100) 
	{
		%mod = 0.015;
	}
	$lastPowerAdjustTime = getSimTime();

	if (%val < 0) 
	{
		$puttPower -= 0.005 + %mod;
	} 
	else 
	{
		$puttPower += 0.005 + %mod;
	}

	clientCmdSetGolfballPower($puttPower);
}

function clientCmdSetGolfballPower(%val) {
	cancel($updatePower);
	$puttPower = %val;
	$puttPower = getMax($puttPower, 0);
	$puttPower = getMin($puttPower, 1);

	// commandToClient(%cl, 'MGC_HUD_SetPower', $puttPower);
	clientCmdMGC_HUD_SetPower($puttPower);
	$updatePower = schedule(1000, 0, commandToServer, 'setGolfballPower', $puttPower);
}

function isGolfball() 
{
	%controlObj = serverConnection.getControlObject();
	if (striPos(%controlObj.getClassName(), "Player") >= 0) 
	{
		%isGolfball = %controlObj.getDatablock() == $GolfballDatablock;
	} 
	else if (%controlObj.getClassName() $= "Camera") 
	{
		%isGolfball = isObject(%orbit = %controlObj.getOrbitObject()) && %orbit.getDatablock() == $GolfballDatablock;
	}
	return %isGolfball;
}

function clientCmdSetGolfMode(%mode) 
{
	$golfMode = %mode;
}

function clientCmdGetGolfballDB(%db) {
	$GolfballDatablock = %db;
}