function clientCmdMGC_VoteInit()
{
	MGC_ClearVoteDlg();
	activatePackage(MGCVotePackage);
	Canvas.pushDialog(MinigolfVotingGui);
}

function clientCmdMGC_VoteEnd()
{
	Canvas.popDialog(MinigolfVotingGui);
	deactivatePackage(MGCVotePackage);
}

function MGC_ClearVoteDlg()
{
	deleteVariables( "$MGC::Vote*" );
	MGC_VoteGroup.deleteAll();
}

function clientCmdMGC_AddVoteMap( %index, %name )
{
	if(%index $= "" || %name $= "")
	{
		return;
	}

	%index *= 1;

	%pos = 0 SPC ($MGC::Vote::Row * 28);

	%thumbname = strreplace( strlwr( %name ), " ", "-" );

	%this = new GuiBitmapCtrl()
	{
		position = "0 0";
		extent = "435 24";
		bitmap = "Add-Ons/Client_Minigolf/res/img/voteItem";

		new GuiMLTextCtrl()
		{
			profile = "MGC_VoteButtonText";
			position = "8 5";
			extent = "425 14";
			text = "<shadow:1:1><shadowcolor:000000>" @ %name;
			selectable = "0";
		};

		new GuiSwatchCtrl()
		{
			position = "0 0";
			extent = "435 24";
			color = "0 0 0 0";
			isEmoticonSwatch = true;
		};

		new GuiBitmapButtonCtrl()
		{
			profile = "MGC_VoteButtonText";
			position = "0 0";
			extent = "435 24";
			text = " ";
			bitmap = "Add-Ons/Client_Minigolf/res/img/voteItem";
			command = "MGC_VoteMap(" @ %index @ ");";
			isMGCVote = true;
			mgcVoteThumb = %thumbname;
		};
	};

	%this.emoticonSwatch = %swatch;
	MGC_VoteGroup.add(%this);

	for(%a = 0; %a < %this.getCount(); %a++)
	{
		%obj = %this.getObject(%a);

		if(%obj.isEmoticonSwatch)
		{
			%this.emoticonSwatch = %obj;
			break;
		}
	}

	$MGC::Vote::Item[%index] = %this;

	$MGC::Vote::Row++;

	%this.tangoMoveTo( %pos, 1000, elastic );
}

function clientCmdMGC_AddVoteEmoticon(%index, %cid)
{
	%this = $MGC::Vote::Item[%index].emoticonSwatch;

	if(!isObject(%this) || %cid $= "" || $MGC::Vote::CIDLocation[%cid])
	{
		return;
	}

	%obj = new GuiBitmapCtrl()
	{
		vertSizing = "center";
		position = 415 SPC 4;
		extent = "16 16";
		bitmap = "Add-Ons/Client_Minigolf/res/img/tick";
		voteCID = %cid;
	};

	%x = 415 - (%this.getCount() * 17);
	%this.add(%obj);

	$MGC::Vote::CIDLocation[%cid] = %this;

	%obj.tangoMoveTo(%x SPC 4, 500, expo);

	alxPlay( alxCreateSource(AudioGui, "Add-Ons/Client_Minigolf/res/snd/ui_click.wav") );
}

function clientCmdMGC_RemoveVoteEmoticon(%cid)
{
	%this = $MGC::Vote::CIDLocation[%cid];

	if(!isObject(%this) || %cid $= "")
	{
		return;
	}

	for(%a = 0; %a < %this.getCount(); %a++)
	{
		%obj = %this.getObject(%a);

		if(%obj.voteCID == %cid)
		{
			%emoticon = %obj;
			break;
		}
	}

	%x = getWord( %emoticon.getPosition(), 0 );

	for(%a = 0; %a < %this.getCount(); %a++)
	{
		%obj = %this.getObject(%a);
		%xx = getWord( %obj.getPosition(), 0 );

		if(%xx < %x)
		{
			%obj.tangoMoveTo( getWords( VectorAdd( %obj.getPosition(), "17 0" ), 0, 1 ), 500, expo );
		}
	}

	%emoticon.delete();

	$MGC::Vote::CIDLocation[%cid] = false;
}

function clientCmdMGC_SetVoteTime(%time)
{
	%time = mFloor(%time);

	MGC_VoteTime.setValue("<just:center><font:Arial:40><color:FFFFFF><shadow:1:1>" @ %time SPC "seconds");
}

function MGC_VoteMap(%index)
{
	commandToServer('VoteMap', %index);
}

if( isPackage( MGCVotePackage ) )
{
	deactivatePackage( MGCVotePackage );
}

package MGCVotePackage
{
	function GuiBitmapButtonCtrl::onMouseEnter( %this )
	{
		// Parent::onMouseEnter( %this );

		if( %this.isMGCVote )
		{
			alxPlay( alxCreateSource(AudioGui, "Add-Ons/Client_Minigolf/res/snd/ui_hover.wav") );

			%thumb = %this.mgcVoteThumb;

			if( %thumb !$= "" )
			{
				%file = "Add-Ons/Client_Minigolf/res/img/thumbnails/" @ %thumb @ ".png";

				echo(%file);

				if( !isFile( %file ) )
				{
					%file = "Add-Ons/Client_Minigolf/res/img/thumbnails/none.png";
				}

				MGC_VoteThumbnail.setBitmap( %file );
			}
		}
	}
};

activatePackage(MGCVotePackage);